//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Server.CancellationTest
{
    
    
    /// <summary>
    /// Contains a command that can be cancelled via the "Cancel Controller" core feature.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("CancellationTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Cancellation Test")]
    public partial interface ICancellationTest
    {
        
        /// <summary>
        /// Starts a command and waits for cancellation
        /// </summary>
        /// <param name="duration">The time the server should wait for the cancellation</param>
        [Tecan.Sila2.ObservableAttribute()]
        [Tecan.Sila2.ThrowsAttribute(typeof(ShouldHaveBeenCancelledException))]
        Tecan.Sila2.IObservableCommand WaitForCancel([Tecan.Sila2.UnitAttribute("s", Second=1)] long duration);
    }
    
    /// <summary>
    /// Happens if the command did not receive a cancellation
    /// </summary>
    public class ShouldHaveBeenCancelledException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public ShouldHaveBeenCancelledException(string message) : 
                base(message)
        {
        }
    }
}
